{$r-}
unit hrac1;

interface
{$DEFINE DELAYED_}

uses proboj0{$IFDEF DELAYED},crt{$ENDIF};

const Ut = 0.47;


type
  phrac_1 = ^hrac_1;
  hrac_1  = object(hrac)
    { toto sa zavola iba raz - na zaciatku }
    procedure inicializuj; virtual;
    { toto sa zavola pri kazdej novej hre }
    procedure nova_hra; virtual;
    { toto sa zavola ak pride nejaka sprava }
    procedure prijmi(s:string; kto:integer); virtual;
    { toto sa vola kazdy tah }
    procedure novy_tah; virtual;

    { toto sa zavola vzdy, ako niekto zautoci }
    procedure zautocil(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto potiahne }
    procedure potiahol(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto prida vojaka }
    procedure pridal(kto,na:integer); virtual;

    private
     firsttime:boolean;
     procedure Hlaska(group:integer);
  end;

var Pole: array[1..Max_Statov] of byte;

implementation
uses crt,graph;

Const hl_count:array[1..6] of integer = (6,5,7,4,9,1);
         { groups:
                    1 - dobytie zony
                    2 - zaciatok hry
                    3 - vyhra (70%)
                    4 - koniec hry
                    5 - Haluze
                    6 - Mena
         }

Const hlasky:array[1..6,0..8] of string =
             (
              ('Next zone has been conquested. Radiation enabled.',
               'Runtime error 217 at 1A43:C968 : Too fast computer',
               'Moo mooo moooo (Moooooose).',
               'Hahaha, je tu lozisko Radioumu!',
               'WANTED: Santo   Reward: $12.56   Dead or Alive',
               'Bachnem, tresknem, ocko vylupnem!',
               '',
               '',
               ''),

              ('Okay, boys, we''re goin'' to beat you!',
               'Hi Billie, how are you & Micro$oft?',
               'Quiet, please...',
               'Not enough memory. Use paper.',
               'Press F13 key anytime to "Integrate Permonik"',
               '',
               '',
               '',
               ''),

              ('Mission complete',
               'The World has been saved!',
               'Runtime error 218: Not enough opponents intelligence',
               'Not good.',
               'Where is my dinner? Where is my dinner? WHERE IS MY DINNER?',
               'Aziz, light!',
               'To hram proti randomom alebo co?',
               '',
               ''),

              ('By the way, how much is the fish?',
               'S panom bohom, idem od vas, neublizil som ziadnemu z vas...',
               'Runtime error 219: Cannot write output log. Disk full.',
               'Runtime error 220: The mouse is hungry',
               '',
               '',
               '',
               '',
               ''),

              ('Nikto ma nema rad...',
               'Som snehova vlocka...',
               'Vsetci su blazni, len ja som lietadlo!',
               'Len on to dokaze!',
               'Kto to tu tlaci tie kaleraby!',
               'Kamenne schody pravotocive...',
               'Dis is one half. Did you leave a room?',
               'QWERTYUIOP (not QWERTZUIOP)',
               'Ja som hrac 2 (aspon dufam)'),

              ('Radioum~# ',
               '',
               '',
               '',
               '',
               '',
               '',
               '',
               '')
              );

Var pal,pal2:PaletteType;

Procedure hrac_1.Hlaska;
Var i:integer;
Begin
  i:=random(hl_count[group]);
  hrac.povedz(Vsetkym,hlasky[group,i]);

{  meno:=hlasky[6,random(hl_count[6])];}

  If group=3 then
  Begin
     SetPalette(1,5);
     delay(150);
     SetAllPalette(pal);
     delay(200);
     SetPalette(1,5);
     delay(150);
     SetAllPalette(pal);
  End;
End;

procedure hrac_1.inicializuj;

begin
  Meno := 'Radioum~# ';
  Farba := $CCAAFF;
  randomize;
end;

procedure hrac_1.nova_hra;

var Q,P,R: byte;


begin
  povedz(Vsetkym,'Starting Windows 98...');
  povedz(Vsetkym,'Looking for opponents........NOT found');

  firsttime:=true;
  GetPalette(pal);

  Hlaska(2);


  P := 0;
  for Q := 1 to Statov do
  begin
    Pole[Q] := Q;
    if Staty[Q].Owner = ID then
    begin
      inc(P);
      R := Pole[P];
      Pole[P] := Pole[Q];
      Pole[Q] := R;
    end;
  end;
end;

procedure hrac_1.novy_tah;

var PZony: array[1..Max_Zones] of real; {Pomer mojich vojakov ku ostatnym}
    PZony2: array[1..Max_Zones] of byte; {Poradie kontinentov na zautocenie}
    VVojaci,MVojaci: array[1..Max_Zones] of byte; {Vsetci vojaci/moji vojaci}
    X,Y,Z: integer;
    MaxUt,MaxOb,MaxRoz: integer;
    Temp: boolean;
    ZOwner: array[1..Max_Zones] of integer;
    ZAll: array[1..Max_Zones] of boolean;
    Isty: array[1..Max_Statov] of boolean;
    PNovych: integer;

    ours:integer;

begin
{############################### Utok #######################################}
{******************** Vyhladanie najvhodnejsej zony *************************}
  Case kolo of
    22 : povedz(Vsetkym,'Mier, mier!');
    23..24 : ;
{    50 : povedz(Vsetkym,'');}
    else If random(50)=13 then Hlaska(5);
  End;

  for X := 1 to Zon do
  begin
    PZony[X] := 0;
    PZony2[X] := 0;
    VVojaci[X] := 0;
    MVojaci[X] := 0;
    ZOwner[X] := -1;
    ZAll[X] := true;
  end;
  for X := 1 to Statov do
  begin
    VVojaci[Staty[X].Zone] := VVojaci[Staty[X].Zone] + Staty[X].Count;
    if Staty[X].Owner = ID then
    MVojaci[Staty[X].Zone] := MVojaci[Staty[X].Zone] + Staty[X].Count;
    if ZOwner[Staty[X].Zone] = -1 then
    ZOwner[Staty[X].Zone] := Staty[X].Owner;
    if ZOwner[Staty[X].Zone] <> Staty[X].Owner then
    ZAll[Staty[X].Zone] := false;
  end;
  for X := 1 to Zon do
  begin
    PZony[X] := MVojaci[X]/VVojaci[X];
    if (PZony[X] < Ut) and (ZAll[X]) and (ZOwner[X] <> ID) then
    PZony[X] := Ut;
  end;
  for X := 1 to Zon do
  begin
    PZony2[X] := X;
    Y := X;
    while (Y > 1) and (PZony[PZony2[Y]] > PZony[PZony2[Y-1]]) do
    begin
      Z := PZony2[Y];
      PZony2[Y] := PZony2[Y-1];
      PZony2[Y-1] := Z;
      dec(Y);
    end;
  end;
{********************* Vyhladanie najvhodnejsieho statu *********************}
  MaxRoz := 0;
  MaxUt := 0;
  MaxOb := 0;
  for X := 1 to Zon do {Pocita zony od najvhodnejsej po najslabsiu}
  if PZony[PZony2[X]] < 1 then
  begin
    for Y := 1 to Statov do {Prehladava kazdy stat v danej zone ...}
    if (Staty[Y].Zone = PZony2[X]) and (Staty[Y].Owner <> ID) then
    begin
      for Z := 1 to Statov do {... a hlada pre neho utocnika}
      if (Staty[Z].Owner = ID) and (Mapa[Z][Y] = 1) and
      (Staty[Z].Count > 1) then
      begin
        if MaxUt = 0 then
        begin
          MaxUt := Z;
          MaxOb := Y;
          MaxRoz := Staty[Z].Count - Staty[Y].Count;
        end else
        if Staty[Z].Count - Staty[Y].Count > MaxRoz then
        begin
          MaxUt := Z;
          MaxOb := Y;
          MaxRoz := Staty[Z].Count - Staty[Y].Count;
        end;
      end;
    end;
    if MaxUt > 0 then X := Zon;
  end;
  if MaxUt > 0 then
  begin
    while (Staty[MaxUt].Count > 1) and (Staty[MaxOb].Owner <> ID) do
       Temp := Utok(MaxUt,MaxOb);
  end;
  if MaxOB <> 0 then
  if Staty[MaxOb].Owner = ID then
  begin
    for X := 1 to Statov do
    if Pole[X] = MaxOb then
    begin
      Z := Pole[X];
      for Y := X-1 downto 1 do
      Pole[Y+1] := Pole[Y];
      Pole[1] := Z;
      X := Statov;
    end;
  end;
{########################## Detekcia celej zony #############################}
  temp:=true; ours:=0;
  For X:=1 to statov do
  Begin
    If ((Staty[X].Zone = Staty[MaxOb].Zone) and (Staty[X].Owner <> ID)) then temp:=false;
    If Staty[x].owner=ID then inc(ours);
  End;
  If ours=Statov then
  Begin
    Hlaska(4);
{    sound(1000); delay(100); nosound;
    delay(1000);}
  End
  Else
  Begin
    If temp then
     If ((ours>=Statov*0.7) and (firsttime)) then
     Begin
       Hlaska(3);
       firsttime:=false;
     End else Hlaska(1);
  End;

{############################## Presuvanie ##################################}
{****************** Urcenie statu, z ktoreho mozeme presuvat ****************}
  for X := 1 to Statov do
  begin
    if Staty[X].Owner = ID then
    begin
      Isty[X] := true;
      for Y := 1 to Statov do
      if (Mapa[X][Y] = 1) and (Staty[Y].Owner <> ID) then
      begin
        Isty[X] := false;
        Y := Statov;
      end;
    end else
    Isty[X] := false;
  end;
  for X := 1 to Statov do
  begin
    if Isty[X] then
    begin
      for Y := 1 to Statov do
      if (Mapa[X][Pole[Y]] = 1) and (Staty[Pole[Y]].Owner = ID) and
      (Staty[Pole[Y]].Count < Max_Vojakov) then
      begin
        if Staty[X].Count + Staty[Pole[Y]].Count >= Max_Vojakov + 1 then
        Temp := Tahaj(X,Pole[Y],Max_Vojakov - Staty[Pole[Y]].Count) else
        Temp := Tahaj(X,Pole[Y],Staty[X].Count - 1);
        Isty[Pole[Y]] := false;
        Y := Statov;
      end;
    end;
  end;
  for X := 1 to Statov do
  begin
    if Isty[X] then
    begin
      for Y := 1 to Statov do
      if (Mapa[X][Pole[Y]] = 1) and (Staty[Pole[Y]].Owner = ID) and
      (Staty[Pole[Y]].Count < Max_Vojakov) then
      begin
        if Staty[X].Count + Staty[Pole[Y]].Count >= Max_Vojakov + 1 then
        Temp := Tahaj(X,Pole[Y],Max_Vojakov - Staty[Pole[Y]].Count) else
        Temp := Tahaj(X,Pole[Y],Staty[X].Count - 1);
        Y := Statov;
      end;
    end;
  end;
{############################## Pridavanie ##################################}
{******************** Vyhladanie najvhodnejsej zony *************************}
  for X := 1 to Zon do
  begin
    PZony[X] := 0;
    PZony2[X] := 0;
    VVojaci[X] := 0;
    MVojaci[X] := 0;
    ZOwner[X] := -1;
    ZAll[X] := true;
  end;
  for X := 1 to Statov do
  begin
    VVojaci[Staty[X].Zone] := VVojaci[Staty[X].Zone] + Staty[X].Count;
    if Staty[X].Owner = ID then
    MVojaci[Staty[X].Zone] := MVojaci[Staty[X].Zone] + Staty[X].Count;
    if ZOwner[Staty[X].Zone] = -1 then
    ZOwner[Staty[X].Zone] := Staty[X].Owner;
    if ZOwner[Staty[X].Zone] <> Staty[X].Owner then
    ZAll[Staty[X].Zone] := false;
  end;
  for X := 1 to Zon do
  begin
    PZony[X] := MVojaci[X]/VVojaci[X];
    if (PZony[X] < Ut) and (ZAll[X]) and (ZOwner[X] <> ID) then
    PZony[X] := Ut;
  end;
  for X := 1 to Zon do
  begin
    PZony2[X] := X;
    Y := X;
    while (Y > 1) and (PZony[PZony2[Y]] > PZony[PZony2[Y-1]]) do
    begin
      Z := PZony2[Y];
      PZony2[Y] := PZony2[Y-1];
      PZony2[Y-1] := Z;
      dec(Y);
    end;
  end;
{********************* Vyhladanie najvhodnejsieho statu *********************}
  MaxRoz := 0;
  MaxUt := 0;
  MaxOb := 0;
  for X := 1 to Zon do {Pocita zony od najvhodnejsej po najslabsiu}
  if PZony[PZony2[X]] < 1 then
  begin
    for Y := 1 to Statov do {Prehladava kazdy stat v danej zone ...}
    if (Staty[Y].Zone = PZony2[X]) and (Staty[Y].Owner <> ID) then
    begin
      for Z := 1 to Statov do {... a hlada pre neho utocnika}
      if (Staty[Z].Owner = ID) and (Mapa[Z][Y] = 1) then
      begin
        if MaxUt = 0 then
        begin
          MaxUt := Z;
          MaxOb := Y;
          MaxRoz := Staty[Z].Count - Staty[Y].Count;
        end else
        if Staty[Z].Count - Staty[Y].Count > MaxRoz then
        begin
          MaxUt := Z;
          MaxOb := Y;
          MaxRoz := Staty[Z].Count - Staty[Y].Count;
        end;
      end;
    end;
    if MaxUt > 0 then X := Zon;
  end;
  if MaxUt > 0 then
  begin
    PNovych := Novych;
    Y := Max_Vojakov - Staty[MaxUt].Count;
    for X := 1 to Y do
    begin
      Temp := Pridaj(MaxUt);
      dec(PNovych);
      if PNovych = 0 then
      X := Y;
    end;
    for X := 1 to Statov do
    begin
      if (Staty[Pole[X]].Owner = ID) and (Staty[Pole[X]].Count < Max_vojakov)
      then
      while (Staty[Pole[X]].Count < max_vojakov) and (PNovych > 0) do
      begin
        Temp := Pridaj(Pole[X]);
        dec(PNovych);
      end;
      if PNovych = 0 then X := Statov;
    end;
  end;
end;

procedure hrac_1.zautocil(kto,z,na:integer);

var X,Y,Q: byte;

begin
  if Staty[Na].Owner = ID then
  begin
    for X := 1 to Statov do
    if Pole[X] = Na then
    begin
      Q := Pole[X];
      for Y := X-1 downto 1 do
      Pole[Y+1] := Pole[Y];
      Pole[1] := Q;
      X := Statov;
    end;
  end;
end;
procedure hrac_1.potiahol(kto,z,na:integer);
begin
  { ??? }
end;
procedure hrac_1.pridal(kto,na:integer);
begin
  {  ??? }
end;

procedure hrac_1.prijmi(s:string; kto:integer);
begin
  { ??? }
  hrac.prijmi(s,kto);
end;

end.