{$r-}
{
ZLABDANA (ZDLABANA ???) KACICKA PROBOJ

author YoYo Siska
co-authors Miro, Gabo
artwork MisoF
}
unit hrac2;

interface

uses proboj0,crt;

const podcen=1.9;

type
  phrac_2 = ^hrac_2;
  hrac_2  = object(hrac)
    { toto sa zavola iba raz - na zaciatku }
    procedure inicializuj; virtual;
    { toto sa zavola pri kazdej novej hre }
    procedure nova_hra; virtual;
    { toto sa zavola ak pride nejaka sprava }
    procedure prijmi(s:string; kto:integer); virtual;
    { toto sa vola kazdy tah }
    function  BestZone : integer;
    procedure StatusZone(iZone : integer; var My,Oni:Byte );
    Procedure CountZones;
    Function  Access2Zone(Z:INteger):Boolean;
    Procedure HladajMosty;
    procedure novy_tah; virtual;
    procedure hlaska(pr:Integer); virtual;
    Procedure Sirena;
    Procedure Sirena2;
    Procedure Crash;

    { toto sa zavola vzdy, ako niekto zautoci }
{    procedure zautocil(kto,z,na:integer); virtual;}
    { toto sa zavola vzdy, ako niekto potiahne }
{    procedure potiahol(kto,z,na:integer); virtual;}
    { toto sa zavola vzdy, ako niekto prida vojaka }
{    procedure pridal(kto,na:integer); virtual;}


  end;

implementation
var AttackFactor:byte;
    dsz,zsz,dvz,zvz:Array[1..Max_Zones] of Byte;
    vzd:Array[1..Max_Statov] of Byte;
    MySt:Array[1..Max_Statov] of Integer;
    MyStates,MaxVZD,Priemer,poc1,pocetv:Integer;
    Mosty:array [1..Max_zones,1..MAx_statov,1..2] of Byte;
    PM:Array[1..MAx_Zones] of Byte;


procedure hrac_2.StatusZone(iZone : integer; var My,Oni:Byte );
var i,j : integer;
    bFound : boolean;
begin
  My := 0; Oni := 0;

  for i := 1 to statov do
   begin
    if staty[i].zone <> iZone then
       begin
        bFound := FALSE;
        for j := 1 to statov do
         begin
          if (mapa[i][j]=1) AND (staty[j].zone = iZone) then
             begin
              bFound := TRUE;
              break;
             end;
         end;
        if not bFound then
           continue;
       end;

    if staty[i].owner = id then
       My := My + staty[i].count
    else
       if staty[i].zone = iZone then
          Oni := Oni + staty[i].count;
   end;
end;

function hrac_2.BestZone : integer;
var i,a,b,best,idx : integer;
begin
 best := 0; idx := 0;
 for i := 1 to zon do
  begin
   StatusZone(i,Byte(a),Byte(b));
   a := trunc(a/(a+b)*100);
   if a > best then
      begin
       best := a;
       idx := i;
      end;
  end;
 BestZone := idx;
end;

Procedure Hrac_2.CountZones;
Var I:Integer;
BEgin
  For I:=1 to zon do Begin dsz[i]:=0; zsz[i]:=0;  dvz[i]:=0; zvz[i]:=0;end;
  For I:=1 to statov do If Staty[i].owner=id then Begin
    Inc(dsz[staty[i].zone]);
    inc(dvz[staty[i].zone],staty[i].count  );
  end
  else Begin
    Inc(zsz[staty[i].zone]);
    Inc(zvz[staty[i].zone], staty[i].count );
  end;

end;

Function Hrac_2.Access2Zone(Z:INteger):Boolean;
Var I,J:Integer;  T:Boolean;
Begin
  T:=False;
  i:=0;
  If dsz[z]>0 then T:=True;
  Repeat inc(I);
   If (Staty[Mosty[z,i,2]].owner=id ) then T:=True;
  until (I>=PM[z]) or T;

  Access2zone:=T;

end;


Procedure Hrac_2.HladajMosty;
Var I,J:Byte; z1,z2:integer;
Begin
  For I:=1 to Zon do PM[i]:=0;
  For I:=1 to statov-1 do
    For J:=I+1 to statov do
    If (staty[i].zone<>staty[j].zone) and (mapa[i,j]=1) then Begin
      z1:=staty[i].zone; z2:=staty[j].zone;
      Inc(PM[z1]);
      Mosty[z1,pm[z1],1]:=i;
      Mosty[z1,pm[z1],2]:=j;

      inc(PM[z2]);
      Mosty[z2,pm[z2],1]:=j;
      Mosty[z2,pm[z2],2]:=i;
    end;
end;

procedure hrac_2.inicializuj;
begin
  Meno:='UROBeNE Hravo';
  farba:=$FFFF80;
end;

procedure hrac_2.nova_hra;
begin
  povedz(VSETKYM, 'A hravo aj vyhrme ');
  HladajMosty;
end;

procedure hrac_2.hlaska(Pr:Integer);

const urazka : array[0..2] of string[25]=
  ('upravene randomy !','zle orezane backtracky !','chybne heuristiky !');
  zaciatky : array[1..10] of string[25]=
  ('Preco ne','Podme ','Co takto ','Zislo by sa ','Tak pojdeme ','Mozme ',
  'Mohli by sme ','Nuz podme ','Mate dovod ne','Treba ');
  slovesa : array[1..15] of string[25]=
  ('zastrelit','umyt','nakreslit','zmalovat','pozut','obesit','otravit',
  'ohlodat','zlikvidovat','opit','zderivovat','zozrat','nastartovat',
  'obzriet','pochovat');
  mena : array[1..15] of string[25] =
  ('Vinka','Palenicu','Davida','medveda','serifa','veducich','sysla','Gaba',
  'fyzikov','kacicku','second-hand spiona','nasho premiera','Santa',
  'Banta','vsetkych');
  miesta : array[1..15] of string[25]=
  ('v tejto hre','na obede','na stanici','pred Alzbetinom','v Trebisove',
  'v i33-ke','na nocnej hre','v Kosicoch pred Tescom','na vylete',
  'na Alfe Centauri','na izbe Jana L.','na Pasienkoch','vo vlaku',
  'pri proteze','pod stolom');
  pzac=10; pslov=15; pmien=15; pmies=15;

var otaz : boolean;
    c : integer;
    s : string;

begin
   case {random(10)} PR of
      0..6 : begin end;
      7 : {single hlaska}
      begin
         case random(13) of
            0 : povedz(vsetkym,'Co cumite ako David na lubovolnu kostru ???');
            1 : povedz(vsetkym,'To kto tu hovori tie kaleraby ?');
            2 : povedz(vsetkym,'Zaberieme vam '+zone[random(zon)+1].meno+' vy '+urazka[random(3)]);
            3 : povedz(vsetkym,'Vsetci sme blazni, iba MisoF je lietadlo');
            4 : povedz(vsetkym,'Ved pockaj, budes si priat, aby ta nenaprogramovali...');
            5 : povedz(vsetkym,'Komu nestaci vlastna hlavicka, nech si kupi ZAPALKY !');
            6 : povedz(vsetkym,'Nie je vsetko zlato, co sa (vy...) blysti...');
            7 : povedz(vsetkym,'Unit lost');
            8 : povedz(vsetkym,'Incomming missile');
            9 : povedz(vsetkym,'Ak mi toto vyjde, bude Jano potrebovat psychoterapiu.');
            10: povedz(vsetkym,'Mozno prijde aj hygienik...');
            11: povedz(vsetkym,'2B OR NOT 2B = FF');
            12: povedz(vsetkym,'Vsak ten random je uplne chory...');
         end;
      end;
      8..9 : {generator}
      begin
         c:=random(pzac)+1;
         if (c=1) or (c=9) or (c=3) then otaz:=true else otaz:=false;
         s:=zaciatky[c]+slovesa[random(pslov)+1];
         s:=s+' '+mena[random(pmien)+1];
         s:=s+' '+miesta[random(pmies)+1];
         if otaz then s:=s+' ?' else s:=s+'.';
         povedz(vsetkym,s);
      end;
   end;
end;


Procedure Hrac_2.Crash;
var I:Integer;
BEgin
  for i :=  1 to 400 do
  begin
{    sound(random(80)+5 + I div 50);
    delay(2);}
  end;
  nosound;
end;

Procedure Hrac_2.Sirena;
Var I:Integer;
Begin
{  i:=440;
  repeat
  i:=Trunc(I*1.1);
  Sound(I);
  Delay(4);
  until I>1000;
  i:=1000;
  repeat
  i:=Trunc(i*(1/1.1));
  Sound(I);
  Delay(1);
  until I<400;

  NoSound;}
end;

Procedure Hrac_2.Sirena2;
Var I:Integer;
Begin
{  For I:=1 to 600 do Begin
    Sound(trunc(sin((I/1000)/PI)*1000)+300);
    Delay(3);
  end;
  For I:=600 downto 200 do Begin
    Sound(trunc(sin((I/1000)/PI)*1000)+300);
    Delay(4);
  end;

  NoSound;}
end;
{-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-0-

-0-0-0-0-0-0-0-0-0-0-0-0-0--0-0-0-0-0-0-0-0-0-0-0-0-0-00-0}
procedure hrac_2.novy_tah;
 var i,j,k:integer; existuje,q:boolean;
 var AttackFactor,naj,naji:integer;
     mu:Array[1..Max_Statov,1..2] of byte;
     smu:Array[1..Max_Statov] of shortint;
     pmu:Integer;




Procedure CountMySt;
Var I:Integer;
Begin
  MyStates:=0;
  For I:=1 to Statov do If Staty[i].owner=id then Begin
    inc(myStates);
    MySt[myStates]:=i;
  end;
end;

Procedure CountVZD;
Var HS,I,J,K:Integer;
    q:integer;
Begin
  For I:=1 to Statov do vzd[i]:=255;
  HS:=0;
  For I:=1 to MyStates do Begin
    For J:=1 to Statov do
      If (Staty[j].owner<>id) and (mapa[j,MySt[i]]=1) then BEgin
        Vzd[i]:=1;
        Inc(Poc1);
        inc(PocetV,staty[myst[i]].count);
      end;
    If VZD[i]=1 then Inc(HS);
  end;
  Priemer:=(Novych+pocetV) div poc1;
  J:=0;

  for q:=1 to 1000 do begin
    if not (HS<MyStates) then break;
    inc(J);
    For I:=1 to MyStates do If vzd[i]=j then Begin
      For K:=1 to MyStates do
        If (Mapa[myst[i],myst[k]]=1) and (j+1<vzd[k]) then Begin
          Vzd[k]:=j+1; MaxVZD:=J+1;
          Inc(HS);
        end;
     end;
  end;

end;


Function MozePresun(a,b:integer):boolean;
BEgin
  If (Mapa[myst[a],myst[b]]=1) and (Vzd[a]>vzd[b]) then
   MozePresun:=True else MozePresun:=False;
end;

Function Min(a,b:Integer):Integer;
Begin
  if A<B then Min:=a else Min:=b;
end;

function strr(x:integer):String;
var s:String;
Begin
  str(x,s);
  strr:=s;
end;

begin
  if kolo=23 then povedz(vsetkym,'Ved mierim, len tolko neskac !!!') else
     HLASKA(Random(30));
{  Povedz(-1,'timetest');}
{  ReadKey;{}
  CountMySt;
  If Mystates=0 then Exit;
  CountVZD;
  CountZones;
  if kolo<20 then Attackfactor:=2 else if kolo<40 then attackfactor:=3 else attackfactor:=4;

  {najlepsia zona}
  j:=1;
  while  zsz[j]=0 do inc(j);
  naj:=j;
  For I:=J to zon do
    if (zsz[i]<>0 ) and (Access2Zone(i)) and
     (  (( zvz[i] )/(dvz[i]+podcen*zvz[i]) )
    <   ((zvz[naj])/(dvz[naj]+Podcen*zvz[naj]))  )
         then  naj:=i;
  pmu:=0;

{attack}
  for I:=1 to statov do
    If (Staty[i].owner<>id) and (staty[i].zone=naj) then
      For J:=1 to MyStates do
        If Mapa[myst[j],i]=1 then Begin
          inc(pmu);
          mu[pmu,1]:=myst[j];
          mu[pmu,2]:=i;
          smu[pmu]:=Staty[myst[j]].count-Staty[i].count;
        end;
   naji:=1;


  {ak nie je dobre utocit na nasom kontim}

   For I:=1 to pmu do If smu[i]>SMU[naji] then naji:=i;
   If {(smu[naji]<2) and} (staty[mu[naji,2]].count=8) then Begin
     for I:=1 to statov do
      If (Staty[i].owner<>id) then
        For J:=1 to MyStates do
          If Mapa[myst[j],i]=1 then Begin
            inc(pmu);
            mu[pmu,1]:=myst[j];
            mu[pmu,2]:=i;
            smu[pmu]:=Staty[myst[j]].count-Staty[i].count;
          end;
     naji:=1;
     For I:=1 to pmu do If smu[i]>SMU[naji] then naji:=i;
   end;

  {utok}
   while {(Staty[mu[naji,1]].count>AttackFactor)and}
      (Staty[mu[naji,2]].owner<>id  )and (utok(mu[naji,1],mu[naji,2]))do
            smu[naji]:=Staty[mu[naji,1]].count-Staty[mu[naji,2]].count  ;

{   povedz(VSETKYM,'utok '+zone[naj].meno+' : '+staty[mu[naji,1]].meno+
         ' '+Strr(staty[mu[naji,1]].count)+' - '+staty[mu[naji,2]].meno+
         ' '+Strr(staty[mu[naji,2]].count));}

  {update dobyteho uzemia}
  If staty[mu[naji,2]].owner=id then Begin
{    povedz(VSETKYM,'Jeto tu');}
   If  zsz[staty[mu[naji,2]].zone]=1 then
     begin Sirena2; delay(30); Crash; end
   else Sirena;
    For I:=1 to mystates do  If (mapa[myst[i],mu[naji,2]]=1) then begin
      if vzd[i]=1 then vzd[i]:=2;
      For J:=1 to statov do if mapa[myst[i],j]=1 then vzd[i]:=1;
    end;
  end else {Povedz(-1,'Sorry')};




{posun}
  {na dobyte policko}
  I:=mu[naji,2];
  If staty[i].owner=id then Begin
     for J:=1 to mystates do
       If (mapa[i,myst[j]]=1) and (vzd[j]>1) then
          Tahaj(myst[j],i,
            Min(Max_Vojakov-staty[i].count, staty[myst[j]].count-1) );
     If staty[i].count<priemer then
       For J:=1 to Mystates do
         if (mapa[i,myst[j]]=1) and (vzd[j]=1) then
          Tahaj(myst[j],i,
            staty[myst[j]].count div 2 );

  end;
  {z utociaceho, ak sa neda odinadial}
  If (Staty[i].count=1) and (staty[mu[naji,1]].count>1) then
    Tahaj(mu[naji,1],i, staty[mu[naji,1]].count div 2);


  For K:=2 to MaxVZD do
    For I:=1 to mystates do If VZD[i]=K then BEgin
      For J:=1 to Mystates do
        If (mapa[myst[i],myst[j]]=1) and (mozepresun(i,j)) then
          Tahaj(myst[i],myst[j],
            Min(Max_Vojakov -staty[myst[j]].count, staty[myst[i]].count-1) );
    end;






{pridaj}


  if (staty[mu[naji,2]].owner<>id) then
    While (novych>0) and (staty[mu[naji,1]].count<priemer+2) and pridaj(mu[naji,1]) do;

  if (staty[mu[naji,2]].owner=id) then
    While (novych>0) and (staty[mu[naji,2]].count<priemer+2) and pridaj(mu[naji,1]) do;

  For I:=1 to zon do If
    zsz[i]=0 then
      For J:=1 to PM[i] do If (staty[Mosty[i,j,2]].owner=id) then
      Begin
        While (novych>0) and (staty[Mosty[i,j,2]].count<=priemer) and
         Pridaj(Mosty[i,j,2]) do ;
      end else begin
        While (novych>0) and (staty[Mosty[i,j,1]].count<=priemer) and
         Pridaj(Mosty[i,j,1]) do ;
      end;



  While (novych>0) do Begin
    naj:=1;
    For I:=2 to Mystates do
      If (vzd[i]=1) and (staty[myst[i]].count<staty[myst[naj]].count) then
      naj := i;
    If staty[myst[naj]].count=max_Vojakov then break;
    pridaj(myst[naj]);
  end;

  If novych>0 then
  For I:=1 to zon do If
    zsz[i]=0 then
      For J:=1 to PM[i] do If (staty[Mosty[i,j,2]].owner=id) then
      Begin
        While (novych>0) and (staty[Mosty[i,j,2]].count<=Max_Vojakov) and
         Pridaj(Mosty[i,j,2]) do ;
      end else begin
        While (novych>0) and (staty[Mosty[i,j,1]].count<=Max_Vojakov) and
         Pridaj(Mosty[i,j,1]) do ;
      end;

  While (novych>0) do Begin
    naj:=1;
    For I:=2 to Mystates do
      If (staty[myst[i]].count<staty[myst[naj]].count) then
      naj := i;
    If staty[myst[naj]].count=max_Vojakov then break;
    pridaj(myst[naj]);
  end;



  { ??? }
end;

(*procedure hrac_2.zautocil(kto,z,na:integer);
begin
  { ??? }
end;
procedure hrac_2.potiahol(kto,z,na:integer);
begin
  { ??? }
end;
procedure hrac_2.pridal(kto,na:integer);
begin
  { ??? }
end;
*)
Function Upcases(A:String):String;
var s:String; I:Integer;
BEgin
  s:='';
  For I:=1 to Length(A) do S:=S+Upcase(a[i]);
  Upcases:=s;
end;
procedure hrac_2.prijmi(s:string; kto:integer);
begin
   S:=Upcases(S);
   IF (Pos('VY',S)>0) or ( pos('TY',S)>0) then Hlaska( 7) else
   If Pos('KUPIM',S)>0 then Povedz(-1,'Nemas tolko, a aj keby si mal ...')
   else
   if pos('MCSLOV, MOTORY',S)>0 then povedz(-1,'McSlov, spiatocku !!!')
   else Hlaska(RAndom(50));
end;

end.