{$r-}
unit hrac4;

interface

uses proboj0;
const pocet_kol_rozhoduj=3;
const utoc_faza1=2;  {utoc ak mas aspon o x hracov viac}
type
  phrac_4 = ^hrac_4;
  hrac_4  = object(hrac)
    { toto sa zavola iba raz - na zaciatku }
    procedure inicializuj; virtual;
    { toto sa zavola pri kazdej novej hre }
    procedure nova_hra; virtual;
    { toto sa zavola ak pride nejaka sprava }
    procedure prijmi(s:string; kto:integer); virtual;
    { toto sa vola kazdy tah }
    procedure novy_tah; virtual;

    { toto sa zavola vzdy, ako niekto zautoci }
    procedure zautocil(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto potiahne }
    procedure potiahol(kto,z,na:integer); virtual;
    { toto sa zavola vzdy, ako niekto prida vojaka }
    procedure pridal(kto,na:integer); virtual;
    procedure BilanciaZony( iZona:integer; var My,Oni:integer);
    procedure vyber_zonu(var iChcemZonu:integer);
    procedure ved_utok;
    procedure utok_faza1;
    procedure presun;
    function presun_faza1:boolean;
    function ennemy_close(s:integer;var sum:integer;var eid:integer):boolean;
    function pridavaj_faza1:boolean;
    procedure pridavaj_oobrana_zony(b:integer);
    function pridavaj_hocico:boolean;
    function pridavaj_cudzi:boolean;
    procedure pridavaj;
end;

implementation

var
  ZonaMoji:array[1..MAX_ZONES] of integer;
  ZonaOni:array[1..MAX_ZONES] of integer;
  zona_my:array[1..MAX_ZONES] of integer;
  zona_con:array[1..MAX_ZONES] of integer;
  iChcemZonu:integer;


procedure hrac_4.vyber_zonu(var iChcemZonu:integer);

var i,j:integer;
    p,MaxPomer:real;
begin
  for i := 1 to Zon do
  begin
    BilanciaZony(i,ZonaMoji[i],ZonaOni[i]);
  end;

  for i:=1 to Zon do zona_con[i]:=0;

  for i:=1 to Statov do if staty[i].owner=id then
  for j:=1 to Statov do if mapa[i][j]=1 then
  begin
    zona_con[staty[i].zone]:=1;
  end;

  MaxPomer := -1;
  iChcemZonu := 1;

  for i := 1 to Zon do if ZonaOni[i]>0 then
  begin
    if (zonaMoji[i]=0) and (zona_con[i]=1) then zonaMoji[i]:=1;
    p:=ZonaMoji[i]/ZonaOni[i];
    begin
      if p> MaxPomer then
      begin
        MaxPomer := ZonaMoji[i]/ZonaOni[i];
        iChcemZonu := i;
      end;
    end;
  end;
end;


procedure hrac_4.inicializuj;
begin

end;

procedure hrac_4.nova_hra;
var i:integer;
begin
  povedz(VSETKYM,'McSlov,  motory.');
  meno:='McSlov Wariors';
  farba:=$ff00ff;
  for i:=1 to ZON do
  begin
    zona_my[i]:=0;
  end;
end;

procedure hrac_4.utok_faza1;
var i,j:integer;
    p,p_max,p_i,p_j:integer;

begin
  p_max:=-100;
  for i:=1 to STATOV do if (staty[i].owner=id) then
  for j:=1 to STATOV do
  if (mapa[i][j]=1) and (staty[j].zone=iChcemZonu) and (staty[j].owner<>id) then
  begin
    p:=staty[i].count-staty[j].count;
    if ((p>=utoc_faza1) or (staty[j].count>=MAX_VOJAKOV-utoc_faza1)) and (p>p_max) then
    begin
      p_max:=p;p_i:=i;p_j:=j;
    end;
  end;
  if (p_max<>-100) and (p_max>=0) then
  begin
    while(staty[p_i].count>1) AND (staty[p_j].owner<>id) do utok(p_i,p_j);
  end;
end;

procedure hrac_4.ved_utok;
begin
  if moze_utocit then utok_faza1;
end;


function hrac_4.ennemy_close(s:integer;var sum:integer;var eid:integer):boolean;
var i,p_max:integer;
begin
  sum:=0;p_max:=-100;eid:=-1;
  for i:=1 to STATOV do
    if (mapa[s][i]=1) and (staty[i].owner<>id) then
    begin
      if staty[i].count>p_max then
        begin
          p_max:=staty[i].count;
          if(staty[i].zone<>iChcemZonu) or (eid=-1) then eid:=i;
        end;
      sum:=sum+staty[i].count;
    end;
  if sum=0 then
  ennemy_close:=false
  else ennemy_close:=true;
end;

function hrac_4.presun_faza1:boolean;
var i,j:integer;
    p,p_n,p_max,p_i,p_j,sum,eid:integer;
begin
  p_max:=-100;
  for i:=1 to STATOV do
  if (staty[i].owner=id) and (staty[i].zone=iChcemZonu) and (ennemy_close(i,p,eid)) then
  begin
    if staty[eid].zone=iChcemZonu then
    for j:=1 to STATOV do if (mapa[i][j]=1) and (staty[j].owner=id) then
    if not ennemy_close(j,sum,eid) then
    begin
      if p>p_max then
      begin
        p_i:=j;p_j:=i;p_n:=staty[j].count-1;p_max:=p;
        if(p_n>MAX_VOJAKOV-staty[i].count) then p_n:=8-staty[i].count;
      end;
    end;
  end;
  if (p_max<>-100) and (p_n>0) then
  begin
    tahaj(p_i,p_j,p_n);
    presun_faza1:=true;
  end else
    presun_faza1:=false;
end;


procedure hrac_4.presun;
var a:boolean;
begin
  {presun_obrana_zony}
  {presun_rusenie}
  while tahov>0 do begin a:=presun_faza1;if a=false then break;end;
end;

function hrac_4.pridavaj_faza1:boolean;
var i,j:integer;
    eid,p,p_n,p_max,p_i,sum:integer;
begin
  p_max:=-100;
  for i:=1 to STATOV do
  if staty[i].count<MAX_VOJAKOV then
  if (staty[i].owner=id) and (staty[i].zone=iChcemZonu) and (ennemy_close(i,p,eid)) then
  begin
    if staty[eid].zone=iChcemZonu then
    begin
      if p>p_max then
      begin
        p_i:=i;p_n:=staty[eid].count-staty[i].count;if p_n<1 then p_n:=1;p_max:=p;
      end;
    end;
  end;
  if p_max<>-100 then
  begin
    for i:=1 to p_n do pridaj(p_i);
    pridavaj_faza1:=true;
  end else
    pridavaj_faza1:=false;
end;

function hrac_4.pridavaj_cudzi:boolean;
var i,j:integer;
    eid,p,p_n,p_max,p_i,sum:integer;
begin
  p_max:=-100;
  for i:=1 to STATOV do
  begin
    if (staty[i].owner=id) and (staty[i].count<MAX_VOJAKOV) then
    if(zona_my[staty[i].zone]=0) then pridaj(i);
    if(novych=0) then break;
  end;
end;
function hrac_4.pridavaj_hocico:boolean;
var i,j:integer;
    eid,p,p_n,p_max,p_i,sum:integer;
begin
  p_max:=-100;
  for i:=1 to STATOV do
  begin
    if (staty[i].owner=id) and (staty[i].count<MAX_VOJAKOV) then pridaj(i);
    if(novych=0) then break;
  end;
end;

procedure hrac_4.pridavaj_oobrana_zony(b:integer);
var enn,i,j:integer;
begin
  for i:=1 to statov do if (staty[i].zone=b) and (staty[i].owner=id) then
  begin
    enn:=0;
    for j:=1 to statov do
      if (staty[j].zone<>b) AND (mapa[i][j]=1) and (staty[j].owner<>id) then
        enn:=enn+staty[j].count;
    while(novych>0)and(enn+3>staty[i].count)and(enn<>0) do
    begin
      if (staty[i].count>=8) or (staty[i].owner<>id) then break;
      pridaj(i);
    end;
  end;
end;

procedure hrac_4.pridavaj;
var a:boolean;
    i:integer;
begin
  {pridaj_obrana_zony}
  {pridaj_rusenie}

  for i := 1 to Zon do zona_my[i]:=0;
  for i := 1 to Zon do
  begin
    BilanciaZony(i,ZonaMoji[i],ZonaOni[i]);
    if(ZonaOni[i]=0) then zona_my[i]:=1;
  end;

  for i:=1 to zon do
    if(novych>0) and (zona_my[i]=1) then pridavaj_oobrana_zony(i);

  while novych>0 do
    begin a:=pridavaj_faza1;if a=false then break;
    end;
    pridavaj_cudzi;
    pridavaj_hocico;

end;

procedure hrac_4.novy_tah;
var i:integer;
    j,k:integer;
    nove,moje:integer;
    utoc:integer;
begin
{
  1.zisti moje uz obsadene zony v zone_my a ich obranu, prip ci su cele
}
{
  2. vyber si zonu na ktoru utocit, v prvych troch tahoch
}
{  if kolo<=pocet_kol_rozhoduj then vyber_zonu(iChcemZonu);}
  vyber_zonu(iChcemZonu);
{kom}
 { povedz(VSETKYM,zone[iChcemZonu].meno);}

{utok}
  ved_utok;
  presun;
  pridavaj;
end;


procedure hrac_4.zautocil(kto,z,na:integer);
begin
  if (kto=id) and (staty[na].meno='Argentina') then
    povedz(-1,'Don''t cry for me Argentina!');
 if random(40)=0 then povedz(Vsetkym,'6F 3^$^%$^%&7fdg^%&^%&G ^uyjh&*^*&85643875tr$%#^GH%%&*%TY@$%');
 if random(30)=1 then povedz(Vsetkym,'Scotty, beam me up..!!@#$#@ Error:No carrier!');
 if random(30)=2 then povedz(Vsetkym,'Two beers or not two beers???');
 if random(40)=3 then povedz(Vsetkym,'Skap ty chrap!');
 if random(40)=4 then povedz(Vsetkym,'Zrychlite to, chlapci.');
end;
procedure hrac_4.potiahol(kto,z,na:integer);
begin
  { ??? }
end;
procedure hrac_4.pridal(kto,na:integer);
begin
  { ??? }
end;

procedure hrac_4.prijmi(s:string; kto:integer);
begin
  { ??? }
{  hrac.prijmi(s,kto);}

end;

procedure hrac_4.BilanciaZony( iZona:integer; var My,Oni:integer);
var
  i,j:integer;
begin
  My := 0;
  Oni := 0;

  for i := 1 to STATOV do if staty[i].zone = iZona then
  begin
    if staty[i].owner = id then
    begin
      {my}
      My := My + staty[i].count;
     end else
     begin
      {oni}
      Oni := Oni + staty[i].count;
     end;
  end;
end;


begin
  {new_player(new(hrac_4, init));}
end.
