{ interna verzia 1.38 }

program proboj;

uses main, proboj0, hrac1,hrac2,hrac3,hrac4,hrac5,klav,rand, gui, crt, graph;



const
    GAMES_ON_MAP = 10;          { pocet hier, ktore sa odohraju na jednej mape }
    TOTAL_MAPS = 1;             { celkovy pocet map }

    { nazvy suborov s mapami }
    map_list : array[1..TOTAL_MAPS] of string[10] = (
      'map00'
{      ,
      'map01'});
var
    { celkove vysledky proboja }
    uplne_vysledky : array[0..MAX_PLAYERS] of integer;
    { vysledky za posledne kolo }
    vysledky : array[0..MAX_PLAYERS] of integer;
    { cislohry }
    hra : integer;



var last_key : char;

{ rozlozenie bodov podla poradia }
function bodovanie(j:integer):integer;
var r:real;
    i:integer;
begin
  r:=10;
  for i:=players_cnt downto j+1 do
    r:=r*3/4;

  bodovanie:=round(r);
end;

{ zaciatok proboja - vytvor summary subor }
procedure proboj_startup;
var t:text;
    i:integer;
begin
  assign(t, 'summary.txt');
  rewrite(t);

  writeln(t,'Hraci:');
  for i:=0 to players_cnt-1 do begin
    writeln(t,i+1,'. ',players[i]^.meno);
  end;

  writeln(t,'Medzivysledky proboja');
  writeln(t,'===========================================================');
  writeln(t,'Kolo      Hrac1      Hrac2      Hrac3      Hrac4      Hrac5');
  close(t);
end;

{ koniec: zapis uplne vysledky }
procedure proboj_shutdown;
var t:text;
var i:integer;
begin
  assign(t, 'summary.txt');
  append(t);
  writeln(t,'-----------------------------------------------------------');
  write(t, 'Spolu');
  for i:=0 to players_cnt-1 do
    if (i=0) then
      write(t, uplne_vysledky[i]:8)
    else
      write(t, uplne_vysledky[i]:11);
  writeln(t);
  close(t);
end;

{ odohraj jednu hru na mape }
procedure play_one_game;
var end_game : boolean;
begin
  gui_reset;
  new_game;

  end_game := false;

  last_key := #0;
  while (last_key<>#27) and (players_playing>1) and (not end_game) and (kolo<1000) do begin
    last_key := #0;

    while (keypressed) do begin
        last_key := readkey;

        case last_key of
          { rychlost hry }
          '0'..'4': gui_set_level(ord(last_key)-$30);
          { koniec kola }
          'T'     : end_game := true;
        end;
    end;

    new_turn;
  end;

  gui_total_update;
end;

{ spocitaj vysledok hry }
procedure game_summary;
var i, j, k : integer;
    min : integer;
    t:text;
begin
  for i:=0 to players_cnt-1 do
    vysledky[i]:=-1;


  for i:=0 to players_cnt-2 do begin
    min := -1;
    for j:=0 to players_cnt-1 do
      if (vysledky[j]=-1) and (min<player_left_in[j]) then begin
        min := player_left_in[j];
        k := j;
      end;
    if min=-1 then
      for j:=0 to players_cnt-1 do
        if (vysledky[j]=-1) and (min<player_score[j]) then begin
          min := player_score[j];
          k := j;
        end;
    vysledky[k]:=players_cnt - i-1;
  end;

  for i:=0 to players_cnt-1 do
    if vysledky[i]=-1 then vysledky[i]:=players_cnt;

  for i:=0 to players_cnt-1 do
    vysledky[i]:=bodovanie(vysledky[i]);

  { zapis medzivysledky do suboru }
  assign(t, 'summary.txt');
  append(t);
  write(t, hra:2, '.');
  for i:=0 to players_cnt-1 do
    if (i=0) then
      write(t, vysledky[i]:10)
    else
      write(t, vysledky[i]:11);

  writeln(t);
  close(t);

  { spocitaj do uplnych vysledkov }

  for i:=0 to players_cnt-1 do
    inc(uplne_vysledky[i], vysledky[i]);

  for i:=1 to players_cnt do
    stat.pl[i].body := uplne_vysledky[i-1];

  gui_summary(players_cnt);
  readkey;
end;

{ Koniec hry - napis uplne vysledky }
procedure total_summary;
var i:integer;
begin

  gui_total_summary(players_cnt);

  readkey;
end;

procedure proboj_register_players;
var i,j,k:integer;
    p:array[0..MAX_PLAYERS] of integer;
begin
  for i:=0 to MAX_PLAYERS do
    p[i]:=i;


  for i:=0 to MAX_PLAYERS do begin
    j:=random(MAX_PLAYERS-i)+i;
    k:=p[j]; p[j]:=p[i]; p[i]:=k;
  end;

  for i:=0 to MAX_PLAYERS do
    case p[i] of
      0: register_player(new(phrac_1, init));
      1: register_player(new(phrac_2, init));
      2: register_player(new(phrac_3, init));
      3: register_player(new(phrac_4, init));
{      4: register_player(new(phrac_5, init));}
      5: ;
    end;
end;

var i,j : integer;

begin
  main_startup;
  gui_startup;

  randomize;

  proboj_register_players;

  hra := 0;
  proboj_startup;

  { zahraj hry na mape }
  for i:=1 to GAMES_ON_MAP do
    for j:=1 to TOTAL_MAPS do begin
      if last_key = #27 then break;
      inc(hra);
      loadmap(map_list[j]);
      play_one_game;
      game_summary;
    end;

  proboj_shutdown;

  total_summary;

  gui_shutdown;
  main_shutdown;
  loadmap_dump;
end.

