unit hrac5;

interface

uses proboj0;

var
  fBezpecnost:real;

type
  phrac_5 = ^hrac_5;
  hrac_5  = object(hrac)
    fSilaNaKontinente: array [1..MAX_ZONES] of real;
    fStaraSilaNaKontinente : array[1..MAX_ZONES] of real;

    nPolickoChceVojakov : array[1..MAX_STATOV] of integer;
    iTahalSomNa : integer;

    function ticho(komu : integer; co : string) : boolean;
    procedure inicializuj; virtual;
    procedure nova_hra; virtual;
    procedure novy_tah; virtual;
    procedure prijmi(s:string; kto:integer); virtual;
    procedure NajdiNajlepsiUtok(iUtocNaKontinent:integer; var iUtocZoStatu:integer; var iUtocNaStat:integer);
    procedure UtocKymPohoda(iUtocZoStatu:integer; iUtocNaStat:integer);
    procedure OdsunVojakov(iZaujmovaZona:integer);

    function VojakovVZone(iZona:integer; iHrac:integer):integer;
    function CudzichVojakovVZone(iZona:integer):integer;

    function StatovOkolo(iStat:integer):integer;
    function CudzichStatovOkolo(iStat:integer):integer;

    function StatovVZone(iZona:integer):integer;
    function CudzichStatovVZone(iZona:integer):integer;

    function VzdialenostStatuKZone(iStat:integer; iZona:integer):integer;
    procedure SpocitajSilyNaKontinentoch;
    function NajlepsiKontinent:integer;
    function MaxSilaNepriatelaOkolo(iStat:integer):integer;
    procedure PridajVojaka( iZonaZaujmu:integer );
    function MojichStatovVZone(iZona:integer):integer;
    procedure SpocitajChtic( iZaujmovaZona:integer );
    procedure SpocitajKamPresunut( iZaujmovaZona:integer );
  end;

implementation

function min(a,b:integer):integer;
begin
     if a < b then
        min := a
     else
         min := b;
end;

procedure hrac_5.inicializuj;
begin
  meno := 'TJ';
  farba := $0000B0;
end;
function hrac_5.ticho(komu : integer; co : string) : boolean;
begin
     ticho := true;
end;

procedure hrac_5.nova_hra;
begin
  ticho(VSETKYM,'Ja som hrac Juro/Tino');
end;

procedure hrac_5.novy_tah;
var i:integer;
    j,k:integer;
    nove,moje:integer;
    utoc:integer;
    fmax: real;
    iUtocNaKontinent: integer;
    iUtocNaStat : integer;
    iUtocZoStatu : integer;
    n1, n2: integer;
    str1,str2,str3,str4:string;
    chyba: integer;
begin

     fBezpecnost := novych;

     {Utok **************************************************************}
     SpocitajSilyNaKontinentoch;

     iUtocNaStat := -1;
     iUtocZoStatu := -1;
     iUtocNaKontinent := NajlepsiKontinent;
     if iUtocNaKontinent < 0 then
        iUtocNaKontinent := 1;
{     ticho(VSETKYM,'Utocim na ' + Zone[iUtocNaKontinent].meno);}



     if true then begin
        { pokusime sa dobit kontinent }
        NajdiNajlepsiUtok(iUtocNaKontinent, iUtocZoStatu, iUtocNaStat);
        if iUtocNaStat < 0 then begin
           iUtocZoStatu := 1;
           iUtocNaStat := 1;
        end;
        if staty[iUtocNaStat].owner = id then
           ticho(VSETKYM, 'E  ------- Na seba');
        if iUtocZoStatu < 0 then
           iUtocZoStatu := 0;

        str(iUtocZoStatu,str1);
        str(iUtocNaStat,str2);
        str(staty[iUtocZoStatu].count,str3);
        str(staty[iUtocNaStat].count,str4);
        ticho(VSETKYM,'Utocim z ' + str1 + ' na ' + str2 + 'Sily: ' + str3 + ':' + str4);

        UtocKymPohoda(iUtocZoStatu, iUtocNaStat)
     end;

     { Presun ****************************************************** }
     iTahalSomNa := -1;
     OdsunVojakov(iUtocNaKontinent);
     OdsunVojakov(iUtocNaKontinent);

     { Pridaj ******************************************************* }
     for i := 1 to 200 do
          if novych > 0 then
             PridajVojaka(iUtocNaKontinent);
     for i := 1 to 200 do begin
         if novych > 0 then begin
            for j:=1 to statov do begin
                if staty[j].owner = id then
                   pridaj(j);
            end;
         end;
     end;
     { Zaver ******************************************************* }
     SpocitajSilyNaKontinentoch;

     for i := 1 to MAX_ZONES do
          fStaraSilaNaKontinente[i] := fSilaNaKontinente[i];

end;

procedure hrac_5.UtocKymPohoda(iUtocZoStatu:integer; iUtocNaStat:integer);
var
   i : integer;
   bUtocDalej : integer;
   nMaxOkoloVojakov : integer;
   chyba : integer;
begin
     bUtocDalej := 1;
     for i := 0 to 4*MAX_VOJAKOV do begin
          if staty[iUtocNaStat].owner = id then
          begin
             ticho(VSETKYM,'Podarilo sa!');
             break;
          end;
          if staty[iUtocZoStatu].count = 1 then
          begin
             ticho(VSETKYM,'Prehral som!');
             break;
          end;
          nMaxOkoloVojakov := MaxSilaNepriatelaOkolo(iUtocZoStatu);
          if round(staty[iUtocZoStatu].count*fBezpecnost) < nMaxOkoloVojakov then begin
             { Bobkacim, uz neutocim}
             ticho(VSETKYM,'Vzdavam utok!');
             break;
          end;

          if utok(iUtocZoStatu, iUtocNaStat)=false then
             ticho(VSETKYM, 'E  ------- Utok');


     end;
end;

procedure hrac_5.NajdiNajlepsiUtok(iUtocNaKontinent:integer; var iUtocZoStatu:integer; var iUtocNaStat:integer);
var
   i, j: integer;
   iUtocimNaTohoto,SilaHraca,NajvacsiaSila: integer;
   Chyba:integer;
   bTestujNa:BOOLEAN;
   bVsetko, k:integer;
   label NovyUtok;
begin
   iUtocimNaTohoto := -1;
   iUtocNaStat := -1;

   NajvacsiaSila := -2;
   for i := 0 to MAX_PLAYERS do
   begin
        if i = id then continue;

        SilaHraca := 0;
        for j := 1 to statov do begin
            if (staty[j].zone = iUtocNaKontinent) and (staty[j].owner = i) then
               inc(SilaHraca,staty[j].count);
        end;

        if SilaHraca = 0 then continue;

        if (SilaHraca > NajvacsiaSila) then begin
           NajvacsiaSila := SilaHraca;
           iUtocimNaTohoto := i;
        end;
   end;

   if NajvacsiaSila = -2 then
      inc(SilaHraca);

   bTestujNa := TRUE;

NovyUtok:

   for i:=1 to statov do begin
       if staty[i].owner <> id then
           continue;
       if staty[i].count <= 1 then
          continue;
       if staty[i].zone <> iUtocNaKontinent then
           continue;
       for j:=1 to statov do begin
           if mapa[i][j] > 1 then
              continue;
           if staty[j].owner = id then
              continue;
           if staty[j].owner <> iUtocimNaTohoto then begin
              if bTestujNa then
                 continue;
           end;
           if staty[j].zone <> iUtocNaKontinent then
              continue;
           if iUtocNaStat = -1 then begin
              iUtocNaStat := j;
              iUtocZoStatu := i;
              continue;
           end;
           if (staty[j].count/staty[i].count) < (staty[iUtocNaStat].count/staty[iUtocZoStatu].count) then begin
              iUtocZoStatu := i;
              iUtocNaStat := j;
           end;
       end;
   end;

   { Skus vypnut podmienku utocenia na najsilnejsieho na kont}
   if (iUtocNaStat = -1) or (iUtocNaStat = -1) then
   begin
        if bTestujNa then begin
           bTestujNa := FALSE;
           goto NovyUtok
        end else
             ticho(VSETKYM,'Tu Kacka,Kacka -- volam 44 55 23');
   end;

   if (iUtocNaStat = -1) or (iUtocNaStat = -1) then
   begin
        { uz mame kontinent, musime dobijat nieco ine }
        for i := 1 to statov do begin
            if iUtocZoStatu >= 0 then
               continue;
            if CudzichStatovOkolo(i) = 0 then
               continue;
            if staty[i].count = 1 then
               continue;
            if staty[i].owner <> id then
               continue;
               { lubovolny }
            for j := 1 to statov do begin
                if (mapa[i][j] = 1) and (staty[j].owner <> id) then begin
                   if iUtocZoStatu = -1 then begin
                      iUtocZoStatu := i;
                      iUtocNaStat := j;
                   end;
                   if staty[iUtocNaStat].count > staty[j].count then begin
                      iUtocZoStatu := i;
                      iUtocNaStat := j;
                   end;
                end;
            end;
        end;
   end;

   for i:=1 to statov do begin
       for j:=1 to statov do begin
          if mapa[i][j] <> 1 then
             continue;
          if (staty[i].owner <> id) or (staty[j].owner = id) then
             continue;
          if staty[i].count <= staty[j].count then
             continue;

          bVsetko := 1;
          for k:=1 to statov do
              if (staty[k].zone = staty[j].zone) and (staty[k].owner <> staty[j].owner) then
                 bVsetko := 0;
          if bVsetko > 0 then begin
             iUtocZoStatu := i;
             iUtocNaStat := j;
          end;
       end;
   end;

end;

procedure hrac_5.prijmi(s:string; kto:integer);
begin
  { ??? }
end;

procedure hrac_5.SpocitajSilyNaKontinentoch;
var
   i : integer;
begin
     for i:=1 to zon do begin
         fSilaNaKontinente[i] := VojakovVZone(i, id)/
                              (VojakovVZone(i, id) + CudzichVojakovVZone(i));
     end;
end;

function hrac_5.NajlepsiKontinent:integer;
var
   i : integer;
   iNajKont : integer;
   chyba : integer;
begin
     iNajKont := -1;
     for i:=1 to zon do begin
         if (CudzichVojakovVZone(i) = 0) then
            continue;
         if (fSilaNaKontinente[i] <> 1) and (iNajKont = -1) then begin
            iNajKont := i;
            continue;
         end;
         if (fSilaNaKontinente[i] <> 1) and (fSilaNaKontinente[iNajKont] < fSilaNaKontinente[i]) then
            iNajKont := i;
     end;
     if iNajKont = -1 then
        ticho(VSETKYM, 'E  ------ NajlepsiKontinent');
     NajlepsiKontinent := iNajKont;
end;


function hrac_5.VojakovVZone(iZona:integer; iHrac:integer):integer;
var
   i:integer;
   nVojakov:integer;
begin
     nVojakov := 0;
     for i := 1 to statov do begin
         if (staty[i].zone = iZona) and (staty[i].owner = iHrac) then
            inc(nVojakov);
     end;
     VojakovVzone := nVojakov;
end;

function hrac_5.CudzichVojakovVZone(iZona:integer):integer;
var
   i:integer;
   nVojakov:integer;
begin
     nVojakov := 0;
     for i := 1 to statov do begin
         if (staty[i].zone = iZona) and (staty[i].owner <> id) then
            inc(nVojakov);
     end;
     CudzichVojakovVzone := nVojakov;
end;

function hrac_5.StatovOkolo(iStat:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=0;
     for i:= 1 to statov do begin
         if mapa[iStat][i] = 1 then inc(n);
     end;
     StatovOkolo:=n;
end;


function hrac_5.CudzichStatovOkolo(iStat:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=0;
     for i:= 1 to statov do begin
         if (mapa[iStat][i] = 1) and (staty[i].owner <> id) then inc(n);
     end;
     CudzichStatovOkolo:=n;
end;

function hrac_5.StatovVZone(iZona:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=0;
     for i:= 1 to statov do begin
         if staty[i].zone = iZona then inc(n);
     end;
     StatovVZone:=n;
end;

function hrac_5.MojichStatovVZone(iZona:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=0;
     for i:= 1 to statov do begin
         if (staty[i].zone = iZona) and (staty[i].owner = id) then inc(n);
     end;
     MojichStatovVZone:=n;
end;

function hrac_5.CudzichStatovVZone(iZona:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=0;
     for i:= 1 to statov do begin
         if (staty[i].zone = iZona) and (staty[i].owner <> id) then inc(n);
     end;
     CudzichStatovVZone:=n;
end;

function hrac_5.VzdialenostStatuKZone(iStat:integer; iZona:integer):integer;
var
   i:integer;
   n:integer;
begin
     n:=statov+1;
     for i:=1 to statov do begin
         if (staty[i].zone = iZona) and (mapa[iStat][i] < n) then
            n := mapa[iStat][i];
     end;
     VzdialenostStatuKZone := n;
end;

procedure hrac_5.SpocitajChtic( iZaujmovaZona:integer );
var
   i,j,k,nSilaNepriatela:integer;
   bMamZonu:BOOLEAN;
begin
     for i := 1 to statov do
         nPolickoChceVojakov[i] := -1;

     for i := 1 to statov do
         nPolickoChceVojakov[i] := 100 - 2*VzdialenostStatuKZone(i,iZaujmovaZona);

     for i := 1 to statov do
         if staty[i].owner = id then
         begin
              {Pre vsetky nase policka -- pocitame silu nepriatela naokolo}
              nSilaNepriatela := 0;
              for j := 1 to statov do begin
                  if (mapa[i][j] = 1) and (staty[j].owner <> id) then begin
                     {Nasli sme nepriatelske policko pri nasom}
                     inc(nSilaNepriatela,staty[j].count);
                  end;
              end;
              if (nSilaNepriatela > 0) then
              begin
                   {S polickom susedi nepriatelske policko}
                   inc(nPolickoChceVojakov[i],400);

                   {Treba rozhodnut ake policka su prioritne --
                                                  v subvncovani vojakmi}
                   if staty[i].count < 2 then
                      inc(nPolickoChceVojakov[i],15+staty[i].count+2*nSilaNepriatela)
                   else
                      inc(nPolickoChceVojakov[i],staty[i].count+2*nSilaNepriatela);
              end;
              {Ak je policko v zujmovej zone, tak je preferovanejsie}
              if staty[i].zone = iZaujmovaZona then
              begin
                   if nSilaNepriatela > 0 then
                        inc(nPolickoChceVojakov[i],1000)
                   else
                       inc(nPolickoChceVojakov[i],50);
              end;
         end;

     for i:= 1 to zon do begin
         bMamZonu := TRUE;
         for j := 1 to statov do begin
             if (staty[j].owner <> id) and (staty[j].zone = i) then
             begin
                  bMamZonu := FALSE;
             end;
         end;

         if bMamZonu then begin
            for j := 1 to statov do begin
                for k := 1 to statov do begin
                    if (staty[j].owner = id) and (staty[j].zone = i) and
                       (mapa[j][k] = 1) and (staty[k].owner <> id) and
                       (staty[k].count+2 >= staty[j].count) then
                       begin
                            inc(nPolickoChceVojakov[j],5000);
                       end;
                end;
            end;
         end;
     end;

{     for i := 1 to statov do
         if staty[i].count = 7 then
            nPolickoChceVojakov[i] := nPolickoChceVojakov/2;
}
{     for i := 1 to statov do
         if staty[i].count = 8 then
            nPolickoChceVojakov[i] := 0;}
end;


procedure hrac_5.SpocitajKamPresunut( iZaujmovaZona:integer );
var
   i,j,k,nSilaNepriatela:integer;
   bMamZonu:BOOLEAN;
begin
     for i := 1 to statov do
         nPolickoChceVojakov[i] := -1;

     for i := 1 to statov do
         nPolickoChceVojakov[i] := 100 - 2*VzdialenostStatuKZone(i,iZaujmovaZona);

     for i := 1 to statov do
         if staty[i].owner = id then
         begin
              {Pre vsetky nase policka -- pocitame silu nepriatela naokolo}
              nSilaNepriatela := 0;
              for j := 1 to statov do begin
                  if (mapa[i][j] = 1) and (staty[j].owner <> id) then begin
                     {Nasli sme nepriatelske policko pri nasom}
                     inc(nSilaNepriatela,staty[j].count);
                  end;
              end;
              if (nSilaNepriatela > 0) then
              begin
                   {S polickom susedi nepriatelske policko}
                   inc(nPolickoChceVojakov[i],400);

                   {Treba rozhodnut ake policka su prioritne --
                                                  v subvncovani vojakmi}
                   if staty[i].count < 2 then
                      inc(nPolickoChceVojakov[i],15+staty[i].count+2*nSilaNepriatela)
                   else
                      inc(nPolickoChceVojakov[i],staty[i].count+2*nSilaNepriatela);
              end;
              {Ak je policko v zujmovej zone, tak je preferovanejsie}
              if staty[i].zone = iZaujmovaZona then
              begin
                   if nSilaNepriatela > 0 then
                        inc(nPolickoChceVojakov[i],1000)
                   else
                       dec(nPolickoChceVojakov[i],50);
              end;
         end;

     for i:= 1 to zon do begin
         bMamZonu := TRUE;
         for j := 1 to statov do begin
             if (staty[j].owner <> id) and (staty[j].zone = i) then
             begin
                  bMamZonu := FALSE;
             end;
         end;

         if bMamZonu then begin
            for j := 1 to statov do begin
                for k := 1 to statov do begin
                    if (staty[j].owner = id) and (staty[j].zone = i) and
                       (mapa[j][k] = 1) and (staty[k].owner <> id) and
                       (staty[k].count+2 >= staty[j].count) then
                       begin
                            inc(nPolickoChceVojakov[j],5000);
                       end;
                end;
            end;
         end;
     end;

{     for i := 1 to statov do
         if staty[i].count = 7 then
            nPolickoChceVojakov[i] := nPolickoChceVojakov/2;
}
{     for i := 1 to statov do
         if staty[i].count = 8 then
            nPolickoChceVojakov[i] := 0;}
end;

function hrac_5.MaxSilaNepriatelaOkolo(iStat:integer):integer;
var
   nMaxOkoloVojakov : integer;
   j : integer;
begin
    nMaxOkoloVojakov := 0;
    for j := 1 to statov do begin
        if staty[j].owner = id then
           continue;
        if (mapa[iStat][j] = 1) and (staty[j].count > nMaxOkoloVojakov) then
           nMaxOkoloVojakov := staty[j].count;
    end;
    MaxSilaNepriatelaOkolo := nMaxOkoloVojakov;
end;

procedure hrac_5.OdsunVojakov(iZaujmovaZona:integer);
var
   i,NajmenejChce,iNajmenejChceStat,NajradsejPrijmeVojakov,iNajradsejPrijmeVojakov:integer;
   Zachrana,Kolko:integer;
   label HladameOdznova;
begin
     SpocitajKamPresunut(iZaujmovaZona);

     Zachrana := 0;
HladameOdznova:
     {Alternativa 1}
     {Presuniem vojakov na to policko, ktore si to zela najviac -- z
      toho policka, ktore si ich zela najmenej}

     {Alternativa 2}
     {Presuniem vojakov z toho policka, ktore si ich zela najmenej -- na
      policko, ktore si ich zela najviac}

     {Najdeme policko, ktore najmenej chce vojakov}
     NajmenejChce := 30000;
     for i := 1 to statov do
     begin
          if staty[i].owner <> id then
             continue;
          if staty[i].count = 1 then
             continue;
          if i = iTahalSomNa then
             continue;
          if (nPolickoChceVojakov[i] < NajmenejChce) then
          begin
               iNajmenejChceStat := i;
               NajmenejChce := nPolickoChceVojakov[i];
          end;
     end;

     if (NajmenejChce > 51) and (NajmenejChce <= 100) then begin
      NajmenejChce := -2;
      for i := 1 to statov do
      begin
          if staty[i].owner <> id then
             continue;
          if staty[i].count = 1 then
             continue;
          if i = iTahalSomNa then
             continue;
          if (nPolickoChceVojakov[i] > NajmenejChce) and (nPolickoChceVojakov[i] > 51) and
                   (nPolickoChceVojakov[i] <= 100) then
          begin
               iNajmenejChceStat := i;
               NajmenejChce := nPolickoChceVojakov[i];
          end;
      end;
     end;


    { if NajmenejChce = 30000 then
        ticho(VSETKYM, 'Nikto nema na presun');}

     {Najdeme susedne policko, ktore ich chce najviac}
     NajradsejPrijmeVojakov := -2;
     for i := 1 to statov do
     begin
          if staty[i].count = 8 then continue;
          if nPolickoChceVojakov[i] = 20000 then continue;

          if nPolickoChceVojakov[i] <= NajmenejChce then
               continue;

          if (mapa[i][iNajmenejChceStat] = 1)
             and (staty[i].owner = id) and (nPolickoChceVojakov[i] > NajradsejPrijmeVojakov) then
          begin
               iNajradsejPrijmeVojakov := i;
               NajradsejPrijmeVojakov := nPolickoChceVojakov[i];
          end;
     end;

     if NajradsejPrijmeVojakov = -2 then
     begin
          {Pruser - nikto tych vojakov neprijme}
          nPolickoChceVojakov[iNajmenejChceStat] := 20000;
          inc(Zachrana);

{          ticho(VSETKYM, 'W   ----  Nikto neprijme vojakov.Skusam dalej!');}

          if (Zachrana < 200) then
              goto HladameOdznova;

          ticho(VSETKYM, 'W   ----  Nikto neprijme vojakov.Za ziadnych okolnostij!');
     end;

     {iNajmenejChceStat}
     {iNajradsejPrijmeVojakov}
     if iNajradsejPrijmeVojakov <= 0 then
        iNajradsejPrijmeVojakov := 1;
     if iNajmenejChceStat <= 0 then
        iNajmenejChceStat := 1;
     Kolko := staty[iNajmenejChceStat].count - 1;
     Kolko := min(Kolko,8 - staty[iNajradsejPrijmeVojakov].count);

     Kolko := min(Kolko,staty[iNajmenejChceStat].count - round(MaxSilaNepriatelaOkolo(iNajmenejChceStat)/fBezpecnost));

     if Kolko < 1 then
     begin
          {Pruser - nikto tych vojakov neprijme}
          nPolickoChceVojakov[iNajmenejChceStat] := 20000;
          inc(Zachrana);

{          ticho(VSETKYM, 'W   ----  Nikto neprijme vojakov.Skusam dalej!');}

          if (Zachrana < 200) then
              goto HladameOdznova;

          ticho(VSETKYM, 'W   ----  Nikto neprijme vojakov.Za ziadnych okolnostij!');
     end;

     if tahaj(iNajmenejChceStat,iNajradsejPrijmeVojakov,Kolko) = false then begin
        ticho(VSETKYM, 'E  ------ Tahaj');
     end;
     iTahalSomNa := iNajradsejPrijmeVojakov;
     {Alternativa 3}
     {Presuniem vojakov medzi polickami, kde je najvacsi rozdiel}
     { toto nejde koli osmickam}

end;

procedure hrac_5.PridajVojaka( iZonaZaujmu:integer );
var
   iNajviacChce,NajviacChce:integer;
   i:integer;
begin
     SpocitajChtic(iZonaZaujmu);

     NajviacChce := -2;

     for i := 1 to statov do
     begin
          if staty[i].count = 8 then
             continue;
          if (NajviacChce < nPolickoChceVojakov[i]) then
          begin
               iNajviacChce := i;
               NajviacChce := nPolickoChceVojakov[i];
          end;
     end;

     pridaj(iNajviacChce);
end;


begin
  {new_player(new(hrac_1, init));}
end.


